#include <string.h>
#include "opora.h"
#include "misc.h"

#define MAX_BUF_SIZE	128				//    
static int RxBufByteCnt;				//   
static char RxBuf[MAX_BUF_SIZE];		//  
static volatile bool TxFlag = false;	//    

//   UART
void UART1Config(void)
{
	//   UART'
	PORTC->FUNC |= (0x1 << (3 * 2)) | (0x1 << (4 * 2));	
	PORTC->ANALOG |= (1 << 3) | (1 << 4);
	PORTC->PWR = (0x3 << (3 * 2)) | (0x3 << (4 * 2));
		
	//    115200
	UART1->IBRD = 0x001A;	
	UART1->FBRD = 0x0003;	
	
	UART1->LCR_H = 0x0060;	//   - 8N1,  
	UART1->CR = 0x0301;		//  UART1, Tx, Rx 

	UART1->ICR = (1 << 4) | (1 << 5);	//        ( )
	UART1->IMSC = (1 << 4) | (1 << 5);	//       
	
	NVIC_EnableIRQ(UART1_IRQn); //    
	
	RxBufByteCnt = 0;	//      
}

//   
void uart_Send(char* buf, unsigned int buf_size)
{	
	unsigned int index;		
	for(index = 0; index < buf_size; index++){	
		TxFlag = false; //   
		UART1->DR = buf[index];			
		while(!TxFlag); //   
	}
}

//   
void uart_Rcv(void)
{
	NVIC_DisableIRQ(UART1_IRQn);	//  
	//       1    " " - 
	//   
	if(RxBufByteCnt > 1 && RxBuf[RxBufByteCnt - 1] == ' '){		
		//    led1on -   VD1
		if(!strncmp(RxBuf, "led1on", 6))
			PORTA->RXTX  |= (1 << 9);
		//    led1off -   VD1
		else if(!strncmp(RxBuf, "led1off", 7))
					PORTA->RXTX  &= ~(1 << 9);		
		RxBufByteCnt = 0;	//    
	}	
	NVIC_EnableIRQ(UART1_IRQn);		//  
}

//   
void UART1_Handler(void)
{
	//    
	if(UART1->MIS & (1 << 4)){
		UART1->ICR |= 1 << 4;		//   		
		if(RxBufByteCnt < (MAX_BUF_SIZE - 1))
			RxBuf[RxBufByteCnt++] = UART1->DR & 0xFF; //     
	}
	//    
	if(UART1->MIS & (1 << 5)){
		UART1->ICR |= 1 << 5;		//   		
		TxFlag = true; //  
	}
}
