#ifndef __LCD_DRV_H__
#define __LCD_DRV_H__

enum{ON = 0x3F, OFF = 0x3E}; 

void lcd_drv_Init(void);
void lcd_drv_OnOffCtrl(unsigned char cmd);
void lcd_drv_SetStartLine(unsigned int line_num);
void lcd_drv_SetPage(unsigned char crystal, unsigned char page_num);
void lcd_drv_SetAddr(unsigned int addr);
void lcd_drv_WriteData(unsigned char data, unsigned int addr);
void lcd_drv_SetEqData(unsigned char data);
void lcd_drv_SetEqDataToPage(unsigned char crystal, unsigned char page, unsigned char data);
void lcd_drv_SetEqDataToPageAddr(unsigned char page, unsigned char start_addr, unsigned char stop_addr, unsigned char data);
#define lcd_drv_Clear()						lcd_drv_SetEqData(0x00)
#define lcd_drv_ClearPage(crystal, page)	lcd_drv_SetEqDataToPage(crystal, page, 0x00)
#define lcd_drv_ClearPageAddr(page, start_addr, stop_addr)	lcd_drv_SetEqDataToPageAddr(page, start_addr, stop_addr, 0x00);
void lcd_drv_PrintChar(unsigned char page, unsigned char addr, unsigned char data, unsigned char show_mode);
void lcd_drv_PrintString(unsigned char page, unsigned char addr, unsigned char* string, unsigned char show_mode);
void lcd_drv_PrintNum(unsigned char page, unsigned char addr, unsigned int val, unsigned char show_mode);
void lcd_drv_Point(unsigned int x, unsigned int y);
void lcd_drv_Byte(unsigned char page, unsigned char addr, unsigned char val);


#endif
