#include <string.h>
#include "opora.h"
#include "itmr.h"
#include "misc.h"

#include "eth_drv.h"
#include "eth.h"

#include "eth_misc.h"

/*
	   Ethernet .
	 ICMP  ping    .
	  ARP .	
*/

//  
void clock_cfg(void)
{
	uint32_t temp;
	RST_CLK->PER_CLOCK |= (1 << 27);				//BKP Clock enable
	temp = BKP->REG_0E;
	temp &= 0xFFFFFFC0;
	BKP->REG_0E = temp | (7 << 3) | 7;				// SelectRI = 0x7, LOW = 0x7; (for core frequency more then 80 MHz);

	RST_CLK->HS_CONTROL=0x00000005;					//HSE - On, Oscillator mode; HSE2 - On, Oscillator mode 
	while((RST_CLK->CLOCK_STATUS&0x0C)!=0x0C);		//Wait until HSE and HSE2 not ready
	RST_CLK->CPU_CLOCK=0x00000002;					//CPU_C1 = HSE = 16 MHz
	RST_CLK->PLL_CONTROL=(5<<8)|(1<<2);			//PLL CPU On, PLL_MULL = 5
	while((RST_CLK->CLOCK_STATUS&0x02)!=0x02);		//wait until PLL CPU not ready
	RST_CLK->PER_CLOCK|=0x08;						//EEPROM_CTRL Clock enable
	EEPROM->CMD=4<<3;								//Delay = 4	 
	RST_CLK->PER_CLOCK&=(~0x08);					//EEPROM_CTRL Clock disable
	RST_CLK->CPU_CLOCK|=0x00000106;					//CPU Clock = 6*16 MHz = 96 MHz
	RST_CLK->ETH_CLOCK=(1<<24)|(1<<27)|(3<<28);		//PHY_CLK_SEL = HSE2, ETH_CLK_EN=1, PHY_CLK_EN=1
	RST_CLK->PER_CLOCK|=(1<<14)|(1<<6)|(1<<21)|(1<<25)|(1<<29); 			//Enable clock for PORTD and PORTB	RST_CLK->ETH_CLOCK=(1<<24)|(1<<27)|(3<<28);		//PHY_CLK_SEL = HSE2, ETH_CLK_EN=1, PHY_CLK_EN=1
	RST_CLK->TIM_CLOCK=0x01000000; /*TIMER1 enable*/
	RST_CLK->UART_CLOCK=(1 << 24);
}

//    -   25
void InPortConfig(void)
{	
	PORTF->ANALOG &= 0xFFFC;	
}

//    -    
void OutPortConfig(void)
{
	PORTA->FUNC |= 0x00000000;	
	PORTA->OE |= (1 << 9) | (1 << 13);
	PORTA->ANALOG |= (1 << 9) | (1 << 13);
	PORTA->PWR |= (0x3 << (9 * 2)) | (0x03 << (13 * 2));
	
	PORTE->FUNC |= 0x00000000;	
	PORTE->OE |= (1 << 6) | (1 << 7);
	PORTE->ANALOG |= (1 << 6) | (1 << 7);
	PORTE->PWR |= (0x3ul << (6 * 2)) | (0x03ul << (7 * 2));
}

int main(void)
{
	unsigned int stime;
	clock_cfg();
	InPortConfig();
	OutPortConfig();	
	
	itmr_Init();		
	//  MAC  ethernet
	ethernet_MACConfig();						
	stime = itmr_GetTick();
	
	while(1){																							
		//   
		eth_FrameProcessing();						
		//       
		if(itmr_IsTime(stime, 1000)){			
			ethernet_PHYState();
			stime = itmr_GetTick();
		}		
	}	
}
