#ifndef __CONSOLE_H__
#define __CONSOLE_H__

#include "misc.h"

//#define KEYBOARD
#define MOUSE

// args: code -   (WE_XXX);
//       data -  .
typedef bool (*TWndEventProc)(unsigned int code, unsigned int data);

//  
enum {
  WE_DRAW,            //  
  WE_BUTTON,					//  
	WE_KEYS,            //  
	WE_MOUSE,						//  
	WE_ENCODER,					// 
  WE_CYCLE,           //  
  WE_SET_CONTEXT,     // ###
  WE_EDIT_CHANGE,     //    
  WE_EDIT_END,        //  
  WE_ELEM_ACT,        //  
  WE_PREV_WND_CLOSED, //   
  WE_PARS_CHANGED     //    
};

//  
enum {
  WET_NONE = 0,
  WET_STATIC,
  WET_BUTTON,
  WET_SELECTOR,
  WET_NUM_EDIT
};

#define NO_WND_ELEM_NUM   0xFFFF

//  
#define WEA_HIDDEN          (1 << 0)    //  
#define WEA_DISABLED        (1 << 1)    //  
#define WEA_NO_NUM_MARK     (1 << 3)		//       
#define WEA_LEADING_ZEROES  (1 << 4)    //  

//  
typedef struct {
  unsigned int  	type;     //  
  int 						x, y;     // 
  unsigned short 	attr;    	// 
  char* 					text;     //    / NULL
  void* 					data;     // .  
  unsigned int 		num;      //   
														// NO_WND_ELEM_NUM   
} TWndElem;

#define NO_WND_CUR_ELEM   0xFFFF

//-------------------------------------------------------
//      
#define BEGIN_WE_TABLE(name)    \
  static TWndElem name[] = {
#define DEFINE_WE(type, x, y, attr, text, data)   \
  { type, (x), (y), (attr), text, (void*)data },
#define END_WE_TABLE()          \
  { WET_NONE } };
//-------------------------------------------------------
	
//  
typedef struct _TWnd {
  unsigned int id;                   //   
  TWndElem* elem_table;       //   
  TWndEventProc event_proc;   //      
  unsigned int  elem_cnt;             //   
  unsigned int  cur_elem;             //   
  int   y_top;                //  
  bool  editing;              //    
  struct _TWnd* next;         //   
} TWnd;

//  
// 
typedef struct {
  char** val_text;
  unsigned int  val_cnt;
  unsigned int  cur_val;
  unsigned int  saved_val;
} TWESelector;

//  
typedef struct {
  unsigned short cur_val;            //  
  unsigned short min_val, max_val;   //  /  
  unsigned int num_pos;            //  
  unsigned char   bcd[5];             // - 
  unsigned int    edit_state;					//   
	unsigned short  saved_val;          //   
} TWENumEdit;

// 
void console_Init(void);
//  
void console_OpenWnd(TWnd* wnd);

void console_CloseWnd(unsigned short res);

//   
void console_Work(void);

void console_DrawWndElem(TWnd* wnd, unsigned int ei);
void console_RemoveWnd(unsigned short res);
void console_RestoreWnd(unsigned int wid);
void console_DrawWnd(void);
void console_SetCurWndElem(unsigned int ei);
void console_ActivateElem(unsigned int ei);
void console_ShowWndElem(unsigned int ei, bool show);
void console_EnableWndElem(unsigned int ei, bool enable);
bool console_IsEditing(void);
void console_SetEditState(bool set);
void console_ParsChanged(void);

void NumEdit_SetVal(TWENumEdit* ne, unsigned short val);

	


#endif
