#ifndef __MISC_H__
#define __MISC_H__

typedef unsigned char bool;
#define true	1
#define false	0
//---------------------------------------------------------------------------------------------------
typedef struct{
	unsigned int q;		// quotient 
	unsigned int r;		// remainder
} uidiv_t;

uidiv_t uidiv(unsigned int dividend, unsigned int divisor);

unsigned int uint2text(unsigned int val, unsigned char* str, unsigned int max_cnt);
//---------------------------------------------------------------------------------------------------

#define PLL_Mul	6 		//   
#define FCLK		16 		//  16 
#define CPU_CLK		((FCLK) * (PLL_Mul))
#define	DELAY(d)	((CPU_CLK) * (d) / 1000 + 1)
#define 	DELAY_160NS 		DELAY(160)
#define 	DELAY_226NS 		DELAY(226)
#define		DELAY_10US		DELAY(10000)
#define		DELAY_50US		DELAY(50000)
#define		DELAY_100US		DELAY(100000)
#define		DELAY_200US		DELAY(200000)
void delay(unsigned int delay);

#define BM(n)		(1ul << (n))

#define LOBYTE(w)         (unsigned char)(w)
#define HIBYTE(w)         (unsigned char)((w) >> 8)
#define MAKEWORD(lo, hi)  ((unsigned short)(unsigned char)(lo) | ((unsigned short)(unsigned char)(hi) << 8))

#define HINIBBLE(b)			(((unsigned char)(b) & 0xF0) >> 4)
#define LONIBBLE(b)			((unsigned int)(b) & 0x0F)

#define EXCHANGE(a) (((unsigned short)(a) >> 8) | (((unsigned short)(a) & 0xFF) << 8))							 

#define NO	((unsigned short)(-1))

unsigned int CalcSum(void* buf, unsigned int size);
unsigned short CalcHeaderCS(void* buf, unsigned int size);

#endif
