/*
 * File: bmp085.h
 * Date: 12.03.2013
 * Denis Zheleznyakov aka ZiB @ http://ziblog.ru
 */

#ifndef BMP085_H_
#define BMP085_H_


typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef short int16_t;
typedef unsigned int uint32_t;
typedef int int32_t;

uint8_t bmp085_init(void);
int16_t bmp085_read_temperature(void);
int32_t bmp085_read_pressure(void);
unsigned int bmp085_getPressure(unsigned char high);

void coefficients_read (void);
uint8_t bmp085_readID(void);
float CalcAltitudeFromPressure(int32_t pressure);
int32_t get_pressure_mmHg(void);
void BMP180_StartTemperatureMeasure(void) ;
void BMP180_StartPressureMeasure(void) ;
void barometr_init(void);
#endif /* BMP085_H_ */
