#include "ds1621s_temp.h"
#include "i2c_soft.h"
#include "itmr.h"
#include "multiplexer.h"
// based on code from McPhalen published at http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1198065647


// device ID and address

#define SLAVE_ID  		  	 0x90 >> 1 
#define ds16readaddr				0x97
#define ds16writeaddr				0x96
#define ACCESS_CFG					0xAC
#define SET_CONTIN_CONV			0x02


// Set configuration register for continious conversion

void ds1621S_cont_conversion(void)
{
		PRESSURE_CS;
	
	i2c_start();
	i2c_wr_U8(ds16writeaddr);
	i2c_wr_U8(ACCESS_CFG);
	i2c_wr_U8(SET_CONTIN_CONV);
	i2c_start();
	i2c_wr_U8(ds16writeaddr);
	i2c_wr_U8(0xA1);
	i2c_wr_U8(0x28);
	i2c_start();
	i2c_wr_U8(ds16writeaddr);
	i2c_wr_U8(0xA2);
	i2c_wr_U8(0x0A);
	i2c_start();
	i2c_wr_U8(ds16writeaddr);
	i2c_wr_U8(0xEE);
	i2c_stop();
	itmr_Delay(15);                                    // allow EE write time to finish
}

char ds1621s_readTemp(void)
{	 char msb;
	

	i2c_start();
	i2c_wr_U8(ds16writeaddr);
	i2c_wr_U8(0xEE);
	i2c_stop();
	itmr_Delay(15);  
	
	i2c_start();
	i2c_wr_U8(ds16writeaddr);
	i2c_wr_U8(0xAA);                          // read temperature
	i2c_start();
	i2c_wr_U8(ds16readaddr);
	
	msb = i2c_rd_U8(0);
	i2c_rd_U8(1);
	i2c_stop();
	//return ((msb << 8) | lsb);	//higher resolution
	return msb;
}

void test_temp_sensor(void)
{		
	
		ds1621S_cont_conversion();
		
		ds1621s_readTemp();
}
