#include "multiplexer.h"
#include "spi.h"
#include "fram.h"
#include "disp.h"
//FM25V10-G

void fram_WriteEN(void)
{
	FRAM_CS;
	SendAndRcvByte(WREN);
	MULTI_CS_HIGH;
}
void fram_WriteDIS(void)
{
	FRAM_CS;
	SendAndRcvByte(WRDI);
	MULTI_CS_HIGH;
}
unsigned char fram_ReadByte (unsigned short address)
{	unsigned char byte;
	FRAM_CS;
	SendAndRcvByte(READ);
	

	SendAndRcvByte((address& 0xFF0000) >> 16);
	
	SendAndRcvByte((address& 0xFF00) >> 8);
	
	SendAndRcvByte(address & 0xFF);
	
	
	byte = SendAndRcvByte(FRAM_DUMMY_BYTE);
	MULTI_CS_HIGH;
	return byte;
}

void fram_WaitForWriteEnd(void)
 {
   unsigned char framstatus = 0;
 
   /*!< Select the FLASH: Chip Select low */
   FRAM_CS;
 
   /*!< Send "Read Status Register" instruction */
   SendAndRcvByte(RDSR);
 
   /*!< Loop as long as the memory is busy with a write cycle */
   do
   {
     /*!< Send a dummy byte to generate the clock needed by the FLASH
     and put the value of the status register in FLASH_Status variable */
     framstatus = SendAndRcvByte(FRAM_DUMMY_BYTE);
 
   }
   while ((framstatus & FRAM_WIP_FLAG) == 1); /* Write in progress */
 
   /*!< Deselect the FLASH: Chip Select high */
   MULTI_CS_HIGH;
 }
void fram_WriteByte (unsigned char byte, unsigned short address)
{	
	fram_WriteEN();
	FRAM_CS;
	SendAndRcvByte(WRITE);
	
	SendAndRcvByte((address& 0xFF0000) >> 16);
	
	SendAndRcvByte((address& 0xFF00) >> 8);
	
	SendAndRcvByte(address & 0xFF);
	
	SendAndRcvByte(byte);
	MULTI_CS_HIGH;
	fram_WaitForWriteEnd();
}

unsigned int fram_id (void)
{	unsigned char pbuf[9];
	unsigned long id;
	#ifndef __MT12864J__
					spi_Init();
					#endif	
	FRAM_CS;
	SendAndRcvByte(RDID);
	pbuf[0] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[1] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[2] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[3] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[4] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[5] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[6] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[7] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	pbuf[8] = SendAndRcvByte(FRAM_DUMMY_BYTE);
	MULTI_CS_HIGH;
	id |= pbuf[8] | (pbuf[7] << 8) | (pbuf[6] << 16) | (pbuf[5] << 24);
	#ifndef __MT12864J__
						spi_DeInit();
						#endif
	return id;
}
