#ifndef __FRAM__
#define __FRAM__

//FM25V10-G

#define WREN		0x06		//Write enable (Latch)
#define WRDI		0x04		//Write disable (Latch)
#define RDSR		0x05		//Read status register
#define WRSR		0x01		//Write status register
#define READ		0x03		//read data bytes
#define WRITE		0x02		//write data bytes
#define SLEEP		0xB9		//enter sleep mode
#define WAKE		0xAB		//exit sleep mode
#define FSTRD		0x0B		// Fast read mode
#define RDID		0x9F		// Read ID
#define SNR			0xC3		// Read S/N
#define FRAM_WIP_FLAG           0x01  /*!< Write In Progress (WIP) flag */
#define FRAM_DUMMY_BYTE         0xA5

#define Address	0xAA
unsigned char fram_ReadByte (unsigned short address);
void fram_WriteByte (unsigned char byte, unsigned short address);

unsigned int fram_id (void);
#endif
