// Define to prevent recursive inclusion -------------------------------------
#ifndef __LOG_H
#define __LOG_H


#define LOG_DIR_LOGS             "LDM_FUNC"              //    
#define LOG_DIR_PATH             "LDM_FUNC/"             //    
#define LOG_FILENAME_TEMPLATE    "TEST00000.LOG"  			   //  
#define LOG_FILE_EXTENSION       ".LOG"            			 //  


typedef enum {
	LOG_OK          = 0x00,        // The operation is completed successfully
	LOG_NOPARTITION = 0x01,        // Partition not found
	LOG_VIERROR     = 0x02,        // Error getting volume information
	LOG_ROOTERROR   = 0x03,        // Error opening root directory
	LOG_CREATEERROR = 0x04,        // File create error
	LOG_ERROR       = 0xff         // Unknown log error
} LOG_Result;


// Public variables
extern unsigned char _SD_present;                           // TRUE if SD card present
extern unsigned char _logging;                              // TRUE if log file was created


// Function prototypes
LOG_Result LOG_Init(void);
unsigned int LOG_NewFile(unsigned int pNum);
unsigned int LOG_FileSync(void);

unsigned int LOG_WriteBin(unsigned char *buf, unsigned int len);
unsigned int LOG_WriteStr(char *str);
unsigned int LOG_WriteInt(int num);
unsigned int LOG_WriteIntU(int num);
unsigned int LOG_WriteIntF(unsigned int num, unsigned char decimals);
unsigned int LOG_WriteDate(unsigned char day, unsigned char month, unsigned char year);
unsigned int LOG_WriteTime(unsigned char hours, unsigned char minutes, unsigned char seconds);
unsigned int LOG_WriteDateTimeTZ(unsigned int time, unsigned int date, char tz);

#endif // __LOG_H
