#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_ssp.h"

#include "mcp23s18.h"
//#include "console.h"
#include "itmr.h"
#include "led.h"
#include "misc.h"
#include "disp.h"
#include "multiplexer.h"
#include "spi.h"

//static int stime, period = 4000;

#define ADDR_MCP23S18		0x20
#define READ_CMD	(((ADDR_MCP23S18) << 1) | 1)
#define WRITE_CMD	((ADDR_MCP23S18) << 1)


void mcp23s18_WriteWord(unsigned char addr, unsigned char data){
	//mux_SetAddr(MUX_EXP_ADDR);
  EXPANDER_CS;	
	//SendAndRcvByte(MCP23S18WRADDR);	
	SendAndRcvByte(MCP23S18WRADDR);
	
	//SendAndRcvByte(addr);	
	SendAndRcvByte(addr);
	
	//SendAndRcvByte(data);	//LOW
	SendAndRcvByte(data);
	
	//SendAndRcvByte(data << 8);		// HIGH
	MULTI_CS_HIGH;
}


unsigned short ReadAddress(unsigned char addr){
	unsigned char  l;
	//mux_SetAddr(MUX_FLASH_ADDR);	
	EXPANDER_CS;
	
	SendAndRcvByte(MCP23S18RDADDR);
	
	SendAndRcvByte(addr);
	
	l = SendAndRcvByte(0);
	
	MULTI_CS_HIGH;
		
	return l;
}

unsigned char mcp23s18_ReadSW3(void)
{	unsigned char bit = 0;
	unsigned short gpio = 0;
	gpio = ReadAddress(GPIOB_BANK0);
	gpio = gpio >> 7;
	bit = gpio;
	return bit;
}

// чтение состояния входов
unsigned short mcp23s18_ReadGPIO(void)
{
	return (ReadAddress(GPIOB_BANK0) << 8) | (ReadAddress(GPIOA_BANK0));  // OLAT - register for outputs, GPIO - register for inputs
	//return (ReadAddress(GPIOA_BANK0));  // OLAT - register for outputs, GPIO - register for inputs
}


unsigned short mcp23s18_PORTS_Init(void)
{	mcp23s18_WriteWord(IOCONA_BANK0, 0x08);
	mcp23s18_WriteWord(IOCONB_BANK0, 0x08);
	mcp23s18_WriteWord(GPPUA_BANK0, 0xFF);  //pull-up enable
	mcp23s18_WriteWord(GPPUB_BANK0, 0xFF);  //pull-up enable
	mcp23s18_WriteWord(GPIOA_BANK0, 0xFF);  
	mcp23s18_WriteWord(GPIOB_BANK0, 0xFF);  
	
	mcp23s18_WriteWord(IODIRA_BANK0 , 0x00); // if F - inputs, if 0 - outputs
	mcp23s18_WriteWord(IODIRB_BANK0 , 0x80); // if F - inputs, if 0 - outputs
	mcp23s18_WriteWord(INTCONA_BANK0, 0x00);  
	mcp23s18_WriteWord(INTCONB_BANK0, 0x00);  
	mcp23s18_WriteWord(DEFVALA_BANK0, 0x00);  
	mcp23s18_WriteWord(DEFVALB_BANK0, 0x00);
	mcp23s18_WriteWord(GPINTENA_BANK0 , 0x00);  //disable INT
	mcp23s18_WriteWord(GPINTENB_BANK0 , 0x00);  //disable INT
	//mcp23s18_WriteWord(OLATA_BANK0 , 0x00);  //disable INT
	//mcp23s18_WriteWord(OLATB_BANK0 , 0x00);  //disable INT
return 0;	
}
void mcp23s18_WritePORTS(unsigned short port_state)
{ unsigned char porta = (port_state);
	unsigned char portb = ((port_state)>> 8);
	mcp23s18_WriteWord(GPIOA_BANK0, porta);
	mcp23s18_WriteWord(GPIOB_BANK0, portb);
	
}
//void mcp23s18_WriteAllGPIO(unsigned char gpio_state, unsigned char crystal)
void mcp23s18_WriteAllGPIO(unsigned char gpio_state)
{	unsigned short ports = 0;
	unsigned char porta = 0;
	unsigned char portb = 0;
	ports = mcp23s18_ReadGPIO();
	ports &= 0xF807;
	ports |= (gpio_state << 3);
	porta = ports;
	portb = ((ports) >> 8);
	mcp23s18_WriteWord(GPIOA_BANK0, porta);
	mcp23s18_WriteWord(GPIOB_BANK0, portb);
	
}

void mcp23s18_WriteBit(unsigned char gpio_pin, unsigned char gpio_state)
{	unsigned short ports = 0;
	unsigned char porta = 0;
	unsigned char portb = 0;
	ports = mcp23s18_ReadGPIO();
	ports &= 0xFFFF;
	if (gpio_pin < 16) {
		!gpio_state ? (ports &= ~(1 << (gpio_pin))):(ports |= (1 << (gpio_pin)));
	}
	porta = ports;
	portb = (ports >> 8);
	
	if (gpio_pin < 8) {
		  
			mcp23s18_WriteWord(GPIOA_BANK0, porta);
	}
	else
	{ 
		mcp23s18_WriteWord(GPIOB_BANK0, portb);
	}
 
}

void mcp23s18_Init(void)
{ 
  mcp23s18_PORTS_Init();	
	mcp23s18_WritePORTS(0xFFFF);
	
}

