#include "multiplexer.h"
#include "spi.h"
#include "mram.h"
#include "disp.h"

//MR25H10CDF

 void mram_WriteEnable(void)
 {
   /*!< Select the FLASH: Chip Select low */
   MRAM_CS;
 
   /*!< Send "Write Enable" instruction */
   SendAndRcvByte(WREN);
 
   /*!< Deselect the FLASH: Chip Select high */
   MULTI_CS_HIGH;
 }
 void mram_WriteDisable(void)
 {
   /*!< Select the FLASH: Chip Select low */
   MRAM_CS;
 
   /*!< Send "Write Enable" instruction */
   SendAndRcvByte(WRDI);
 
   /*!< Deselect the FLASH: Chip Select high */
   MULTI_CS_HIGH;
 }
unsigned char mram_ReadByte (unsigned short address)
{	unsigned char byte;
	
	
	MRAM_CS;
	SendAndRcvByte(READ);
	
	
	SendAndRcvByte((address& 0xFF0000) >> 16);
	
	SendAndRcvByte((address& 0xFF00) >> 8);
	
	SendAndRcvByte(address & 0xFF);
	
	byte = SendAndRcvByte(MRAM_DUMMY_BYTE);
	MULTI_CS_HIGH;

	return byte;
}

void mram_WaitForWriteEnd(void)
 {
   unsigned char mramstatus = 0;
 
   /*!< Select the FLASH: Chip Select low */
   MRAM_CS;
 
   /*!< Send "Read Status Register" instruction */
   SendAndRcvByte(RDSR);
 
   /*!< Loop as long as the memory is busy with a write cycle */
   do
   {
     /*!< Send a dummy byte to generate the clock needed by the FLASH
     and put the value of the status register in FLASH_Status variable */
     mramstatus = SendAndRcvByte(MRAM_DUMMY_BYTE);
 
   }
   while ((mramstatus & MRAM_WIP_FLAG) == 1); /* Write in progress */
 
   /*!< Deselect the FLASH: Chip Select high */
   MULTI_CS_HIGH;
 }

void mram_WriteByte (unsigned char byte, unsigned short address)
{	

	mram_WriteEnable();
	
	MRAM_CS;
	
	
	
	SendAndRcvByte(WRITE);
	
	SendAndRcvByte((address& 0xFF0000) >> 16);
	
	SendAndRcvByte((address& 0xFF00) >> 8);
	
	SendAndRcvByte(address & 0xFF);
	
	
	SendAndRcvByte(byte);
	MULTI_CS_HIGH;
	
	mram_WaitForWriteEnd();

}
