#ifndef __MRAM__
#define __MRAM__

//MR25H10CDF

#define WREN		0x06		//Write enable (Latch)
#define WRDI		0x04		//Write disable (Latch)
#define RDSR		0x05		//Read status register
#define WRSR		0x01		//Write status register
#define READ		0x03		//read data bytes
#define WRITE		0x02		//write data bytes
#define SLEEP		0xB9		//enter sleep mode
#define WAKE		0xAB		//exit sleep mode
#define Address	0xAA
#define MRAM_WIP_FLAG           0x01  /*!< Write In Progress (WIP) flag */
#define MRAM_DUMMY_BYTE         0xA5

unsigned char mram_ReadByte (unsigned short address);
void mram_WriteByte (unsigned char byte, unsigned short address);

#endif
