#ifndef __sFLASH__
#define __sFLASH__

//M25P128

#define sFLASH_CMD_WREN 			 0x06 //Write Enable 
#define sFLASH_CMD_WRDI 			 0x04 //Write Disable
#define sFLASH_CMD_RDID 			 0x9F //Read Identification
#define sFLASH_CMD_RDSR 			 0x05 //Read Status Register

#define sFLASH_CMD_READ 			 0x03 //Read Data Bytes 
#define sFLASH_CMD_FSTRD		   0x0B //Read Data Bytes

#define sFLASH_CMD_WRITE 				 0x02 //Page Program
#define sFLASH_CMD_SE 				 0xD8 //Sector Erase
#define sFLASH_CMD_BE 				 0xC7 //Bulk Erase
 
 #define sFLASH_WIP_FLAG           0x01  /*!< Write In Progress (WIP) flag */
 
 #define sFLASH_DUMMY_BYTE         0xA5
 #define sFLASH_SPI_PAGESIZE       0x100
 
 #define sFLASH_M25P128_ID         0x202018
 #define sFLASH_M25P64_ID          0x202017

 void sFLASH_DeInit(void);
 void sFLASH_Init(void);
 void sFLASH_EraseSector(unsigned long SectorAddr);
 void sFLASH_EraseBulk(void);
 void sFLASH_WritePage(unsigned char* pBuffer, unsigned long WriteAddr, unsigned short NumByteToWrite);
 void sFLASH_WriteBuffer(unsigned char* pBuffer, unsigned long WriteAddr, unsigned short NumByteToWrite);
 void sFLASH_ReadBuffer(unsigned char* pBuffer, unsigned long ReadAddr, unsigned short NumByteToRead);
 unsigned long sFLASH_ReadID(void);
 void sFLASH_StartReadSequence(unsigned long ReadAddr);
 
 
 unsigned char sFLASH_ReadByte(void);
 unsigned char sFLASH_SendByte(unsigned char byte);
 unsigned short sFLASH_SendHalfWord(unsigned short HalfWord);
 void sFLASH_WriteEnable(void);
 void sFLASH_WaitForWriteEnd(void);
 void sFLASH_test(void);


#endif

