#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include "ds1339_RTC.h"


static TWENumEdit hour = { 0, 0, 23, 3 };
static TWENumEdit min = { 0, 0, 59, 3 };
static unsigned char alarm_hour, alarm_min;

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_NUM_EDIT,   0, 0, 0, "", &hour)
  DEFINE_WE(WET_NUM_EDIT,   0, 1, 0, "", &min)

END_WE_TABLE()


static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ALARM, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				NumEdit_SetVal(&hour, alarm_hour);
				NumEdit_SetVal(&min, alarm_min);
      }
      break;
			
			case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 0:
					alarm_hour = hour.cur_val;
					break;
				case 1:
					alarm_min = min.cur_val;
					break;
				
			}
			alarm_set(alarm_hour,alarm_min,0);
			break;
  }

  return false;
}
void wnd_alarm(void)
{ 
  console_OpenWnd(&Wnd);
}
