#include <stdio.h>
#include <string.h>
#include "itmr.h"
#include "disp.h"
#include "console.h"
#include "wnds.h"
#include "keyboard.h"
#include "button.h"
#include "adc.h"
#include "dac.h"
#include "uart.h"
#include "wnds_func.h"

static char ADCRes[32];

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_SURRENT_SENSE, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  unsigned int sample;
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, " :");				
							
      }
      break;
		case WE_BUTTON:
			switch(data){
				case LEFT:
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_CYCLE:								
			if(adc_Work(&sample)){				
				sample = (float)706*sample/1000;
				if (sample > 1600)	sample = 1000*(sample - 1600);
								else sample = 0;
				sample = (float) (sample/70);
				sprintf(ADCRes, "%3.3f% ", (float)sample );
				disp_ShowStr(0, 1, ADCRes);
								
			}
			
			break;
  }

  return true;
}

void wnd_current_sens(void)
{ 
  adc_Init();
	console_OpenWnd(&Wnd);
}
