#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include "M95M02.h"
#include <rtc.h>
#include <stdlib.h>
#include "spi.h"
#include "disp.h"

static TWENumEdit address = { 0, 0, 100, 3 };

BEGIN_WE_TABLE(ElemTable)
DEFINE_WE(WET_BUTTON,   0, 0, 0, "EEPROM:", 0)
	DEFINE_WE(WET_BUTTON,   0, 1, 0, "  ", 0)
  DEFINE_WE(WET_BUTTON,   0, 2, 0, " ", 0)
  DEFINE_WE(WET_BUTTON,   0, 3, 0, "  ", 0)
  DEFINE_WE(WET_BUTTON,   0, 4, 0, ". . ", 0)
	DEFINE_WE(WET_NUM_EDIT, 0, 5, 0, "", &address)

END_WE_TABLE()

static unsigned char read_byte, address_val = 100;
static unsigned char generated_num = 0;

static bool EventProc(unsigned int code, unsigned int data);

int sprintf( char *, const char *, ...);

static TWnd Wnd = { WID_EEPROM, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{ char buffer[32];

	TTime CurTime = rtc_GetTime();
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				
      }
      break;
			
			
			case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 0:
					
				break;
				case 1:		
					#ifndef __MT12864J__
					spi_Init();
					#endif						
				read_byte = M95M02_read(address_val);
					#ifndef __MT12864J__
						spi_DeInit();
						#endif
				sprintf(buffer, ": %d", read_byte);
						disp_ShowStr(2, 6, buffer);	
					break;
				case 2:		
					#ifndef __MT12864J__
					spi_Init();
					#endif					
					M95M02_write(address_val,255);
						#ifndef __MT12864J__
						spi_DeInit();
						#endif
					break;
				case 3:
					#ifndef __MT12864J__
					spi_Init();
					#endif				
					M95M02_write(address_val,generated_num);
					#ifndef __MT12864J__
						spi_DeInit();
						#endif
					break;
				case 4:
					//Generate and display number	  
						CurTime = rtc_GetTime();
						srand(CurTime.msec);
						generated_num = (char) rand();
						sprintf(buffer, "%d", generated_num);
						disp_ShowStr(17, 4, buffer);
					break;
								
			
				default:
					break;
			}
			break;
			
			case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 5:
					address_val = address.cur_val;
					break;
				
			}
			
			break;
  }

  return false;
}
void wnd_eeprom(void)
{ 
  console_OpenWnd(&Wnd);
}
