#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include "bmp085.h"		//pressure
#include "ds1621s_temp.h"		//thermometr

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_BUTTON,   0, 0, 0, "", 0)	
	DEFINE_WE(WET_BUTTON,   0, 1, 0, "", 0)	
	DEFINE_WE(WET_BUTTON,   0, 2, 0, "", 0)	
	DEFINE_WE(WET_BUTTON,   0, 3, 0, " . ", 0)
  DEFINE_WE(WET_BUTTON,   0, 4, 0, " ", 0)
	DEFINE_WE(WET_BUTTON,   0, 5, 0, "MicroSD ", 0)	
	DEFINE_WE(WET_BUTTON,   0, 6, 0, "M-RAM", 0)	
	DEFINE_WE(WET_BUTTON,   0, 7, 0, "F-RAM", 0)	
	DEFINE_WE(WET_BUTTON,   0, 8, 0, "EEPROM", 0)	
	DEFINE_WE(WET_BUTTON,   0, 9, 0, "FLASH-", 0)	  
	DEFINE_WE(WET_BUTTON,   0, 10, 0, "Expander MCP23S18", 0)	


END_WE_TABLE()

static bool EventProc(unsigned int code, unsigned int data);
int sprintf( char *, const char *, ...);
static unsigned int stime;

static TWnd Wnd = { WID_FUNC, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{
	short temperature;
	char buffer[32];
  switch (code) {
    case WE_DRAW:
      if (data == 0) {

      }
      break;
			case WE_CYCLE:
						if(itmr_IsTime(stime, 1000ul)){		
								temperature = bmp085_read_temperature();
								temperature = (float)(temperature/1000);
								sprintf(buffer, ".(DS1621):%d*C", ds1621s_readTemp());
								disp_ShowStr(2, 0, buffer);		
								sprintf(buffer, ".(BMP085):%d*C", temperature);
								disp_ShowStr(2, 1, buffer);		
		
								sprintf(buffer, ". %d ...", get_pressure_mmHg());
								disp_ShowStr(2, 2, buffer);		
						}
			break;
		case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 0:
				case 1:
				case 2:
				case 3:				
					wnd_rtc();	
					
					break;
				
				case 4:
					wnd_current_sens();
					break;
				case 5:
					wnd_microsd();
					break;
				case 6:
					wnd_mram();
					break;
				case 7:
					wnd_fram();
					break;				
				case 8:
					wnd_eeprom();
					break;		
				case 9:
					wnd_sflash();
					break;
				case 10:
					wnd_mcp23s18();
					break;
				default:
					break;
			}
			break;
  }

  return false;
}

void wnd_func(void)
{ ds1621S_cont_conversion();
	
	bmp085_read_temperature();
	stime = itmr_GetTick();
  console_OpenWnd(&Wnd);
}
