#include <string.h>
#include <stdio.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "keyboard.h"
#include "button.h"
#include "mcp23s18.h"
#include "spi.h"

static unsigned int ShowTimer;
unsigned short port_state = 0xAA55;
static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_MCP23S18, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{		char buffer[32];
	
	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, " ");
				disp_ShowStr(0, 1, " 5");
				disp_ShowStr(0, 2, "PA: 0 1 2 3 4 5 6 7");
				
				disp_ShowStr(0, 4, "PB: 0 1 2 3 4 5 6 7");
				
      }
      break;   
		case WE_BUTTON:
			switch(data){
				case LEFT:
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_CYCLE:		
			
	if(itmr_IsTime(ShowTimer, 5000)){
		if(port_state == 0xAA55){			
			port_state = 0x55AA;		
		}
		else{		
		port_state = 0xAA55;		
		}			
		ShowTimer = itmr_GetTick();		
	}
		#ifndef __MT12864J__
					spi_Init();
					#endif	
						mcp23s18_WritePORTS(port_state);
					#ifndef __MT12864J__
						spi_DeInit();
						#endif
		
			if(itmr_IsTime(ShowTimer, 100ul)){
				if (port_state == 0xAA55) {
					sprintf(buffer, "1 0 1 0 1 0 1 0");
					disp_ShowStr(4, 3, buffer);	
					sprintf(buffer, "0 1 0 1 0 1 0 1");
					disp_ShowStr(4, 5, buffer);	
				}
					else { 
					sprintf(buffer, "0 1 0 1 0 1 0 1");
					disp_ShowStr(4, 3, buffer);	
					sprintf(buffer, "1 0 1 0 1 0 1 0");
					disp_ShowStr(4, 5, buffer);	
					}
					
			}
			break;
  }
  return true;
}

void wnd_mcp23s18(void)
{ 	
	ShowTimer = itmr_GetTick();
  console_OpenWnd(&Wnd);
}
