#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include "sdcard.h"
#include "disp.h"
#include "spi.h"
#include "main.h"
#include "keyboard.h"
#include "button.h"
#include "wdt.h"
#include "log.h"

int sprintf( char *, const char *, ...);

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_BUTTON,   0, 0, 0, "-  ", 0)
	DEFINE_WE(WET_BUTTON,   0, 1, 0, " ", 0)
  
	

END_WE_TABLE()



static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_MICROSD, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{ char buffer[32];
	unsigned char success = 0;
	
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				
      }
      break;
			
			case WE_CYCLE:
			
			break;
		
			case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 0:
					wnd_sd_info();
				break;
				case 1:
					sprintf(buffer,"..........");
					disp_ShowStr(0,4,buffer);
					sprintf(buffer,"                  ");
					disp_ShowStr(0,5,buffer);
						#ifndef __MT12864J__
						spi_Init();
						#endif
						success = SD_Make_File(time_buf, temp_buf, pres_buf);
						#ifndef __MT12864J__
						spi_DeInit();
						#endif
						if (success) {							
					sprintf(buffer," ");
					disp_ShowStr(0,4,buffer);
					sprintf(buffer,"  %s", LOG_DIR_PATH);
					disp_ShowStr(0,5,buffer);
						}
						
						clear_log_loop();
					
		
					break;
				
				
				default:
					break;
			}
			break;
			
  }

  return false;
}
void wnd_microsd(void)
{ SDResult_TypeDef init_result;
	init_result = SD_Init();
	#ifndef __MT12864J__
						spi_DeInit();
						#endif
	
	
  console_OpenWnd(&Wnd);
	
	if (init_result != SDR_Success) {
		
		
		disp_ShowStr(0, 0, "!                ");
		disp_ShowStr(0, 1, "SD   ");
		wdt_ReLoad();		
		delay(10000000);
		console_CloseWnd(0);
	}
}
