#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include <rtc.h>
#include "ds1339_RTC.h"

TTime rtc_time_date;

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_BUTTON,   0, 0, 0, "", 0)		
	DEFINE_WE(WET_BUTTON,   0, 1, 0, " ", 0)		
	DEFINE_WE(WET_BUTTON,   0, 2, 0, "- ", 0)	  
	DEFINE_WE(WET_BUTTON,   0, 3, 0, ". ", 0)	  

END_WE_TABLE()

static bool EventProc(unsigned int code, unsigned int data);

int sprintf( char *, const char *, ...);

static TWnd Wnd = { WID_RTC, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{
	char buffer[32];

	
  switch (code) {
    case WE_DRAW:
      if (data == 0) {

      }
      break;
			case WE_CYCLE:
						rtc_time_date = ds1339_read_time();
						sprintf(buffer, " %02d.%02d.%02d %02d:%02d:%02d ", rtc_time_date.date,rtc_time_date.month,rtc_time_date.year, rtc_time_date.hour, rtc_time_date.min, rtc_time_date.sec);
							disp_ShowStr(0, 6, buffer);	
						disp_ShowStr(0, 5, "/ (DS1339):");	
							
			break;
		case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 0:				
				rtc_null();
					break;
				case 1:				
				wnd_rtc_set();
					break;
				case 2:
					system_time_synchronize();
					break;
				case 3:
					wnd_alarm();
					break;
								
			
				default:
					break;
			}
			break;
  }

  return false;
}

void wnd_rtc(void)
{ 
  console_OpenWnd(&Wnd);
}
