#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include "ds1339_RTC.h"

static TWENumEdit date = { 0, 0, 31, 3 };
static TWENumEdit month = { 0, 0, 12, 3 };
static TWENumEdit year = { 0, 0, 99, 3 };
static TWENumEdit hour = { 0, 0, 23, 3 };
static TWENumEdit min = { 0, 0, 59, 3 };
static TWENumEdit sec = { 0, 0, 59, 3 };
static unsigned char time_date, time_month, time_year, time_hour, time_min, time_sec;

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_NUM_EDIT,   0, 0, 0, "", &date)
  DEFINE_WE(WET_NUM_EDIT,   0, 1, 0, "", &month)
	DEFINE_WE(WET_NUM_EDIT,   0, 2, 0, "", &year)
	DEFINE_WE(WET_NUM_EDIT,   0, 3, 0, "", &hour)
  DEFINE_WE(WET_NUM_EDIT,   0, 4, 0, "", &min)
	DEFINE_WE(WET_NUM_EDIT,   0, 5, 0, "", &sec)

END_WE_TABLE()


static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_RTC_SET, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				NumEdit_SetVal(&date, time_date);
				NumEdit_SetVal(&month, time_month);
				NumEdit_SetVal(&year, time_year);
				NumEdit_SetVal(&hour, time_hour);
				NumEdit_SetVal(&min, time_min);
				NumEdit_SetVal(&sec, time_sec);
      }
      break;
			
			case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 0:
					time_date = date.cur_val;
					break;
				case 1:
					time_month = month.cur_val;
					break;
				case 2:
					time_year = year.cur_val;
					break;
				case 3:
					time_hour = hour.cur_val;
					break;
				case 4:
					time_min = min.cur_val;
					break;
				case 5:
					time_sec = sec.cur_val;
					break;
			}
			rtc_set(time_date,time_month,time_year,time_hour,time_min,time_sec);
			break;
  }

  return false;
}
void wnd_rtc_set(void)
{ 
  console_OpenWnd(&Wnd);
}
