#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "wnds_func.h"
#include "sflash.h"
#include "disp.h"
#include "spi.h"
#include "keyboard.h"

int sprintf( char *, const char *, ...);

static TWENumEdit address = { 0, 0, 100, 3 };

BEGIN_WE_TABLE(ElemTable)
DEFINE_WE(WET_BUTTON,   0, 0, 0, "SFLASH ID:", 0)
	DEFINE_WE(WET_BUTTON,   0, 1, 0, " ", 0)
  DEFINE_WE(WET_BUTTON,   0, 2, 0, " ", 0)
  DEFINE_WE(WET_BUTTON,   0, 3, 0, " ", 0)
	DEFINE_WE(WET_NUM_EDIT, 0, 4, 0, "", &address)
	

END_WE_TABLE()

static unsigned char address_val = 100;


static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_SFLASH, ElemTable, EventProc, 0 };


static bool EventProc(unsigned int code, unsigned int data)
{ char buffer[32];
	unsigned int ID = 0;
	
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				
      }
      break;
			
			
			case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 0:
							#ifndef __MT12864J__
					spi_Init();
					#endif	
					ID = sFLASH_ReadID();
						#ifndef __MT12864J__
						spi_DeInit();
						#endif
						sprintf(buffer, "%x", ID);
						disp_ShowStr(12, 0, buffer);		
				break;
				case 1:		
			    wnd_read_page(address_val);
		
					break;
				case 2:		
					sFLASH_EraseSector(address_val);
					break;
				case 3:
				
					wnd_write_page(address_val);
					break;
				
				default:
					break;
			}
			break;
			
			case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 4:
					address_val = address.cur_val;
					break;
				
			}
			
			break;
  }

  return false;
}
void wnd_sflash(void)
{ keyboard_Init();
  console_OpenWnd(&Wnd);
}
