#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "button.h"
#include "keyboard.h"
#include "sflash.h"
#include "wnds_func.h"
#include "disp.h"
#include "spi.h"

static unsigned short CurXPos, CurYPos;
static unsigned char pbuf[255], i = 0, page_address;

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_WR_PAGE, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, " ");
				disp_ShowStr(0, 1, "  ");
				disp_ShowStr(0, 2, "  ");
				disp_ShowStr(0, 3, "Flash-");
      }
			
      break;   
		case WE_BUTTON:
			switch(data){
				case LEFT:
					#ifndef __MT12864J__
					spi_Init();
					#endif	
					sFLASH_EraseSector(page_address);
					sFLASH_WriteBuffer(pbuf,page_address, i);
					#ifndef __MT12864J__
						spi_DeInit();
						#endif
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
						#ifndef __MT12864J__
					spi_Init();
					#endif	
					sFLASH_EraseSector(page_address);
					sFLASH_WriteBuffer(pbuf,page_address, i);
					#ifndef __MT12864J__
						spi_DeInit();
						#endif
					console_CloseWnd(0);
					break;
				default:
					pbuf[i] = data;
					i++;
					if(CurYPos >= disp_YSize()) CurYPos = 1;
					else{
						if(CurXPos >= disp_XSize() - 1) {
							CurXPos = 0;
							CurYPos++;
						}
					}							
					disp_ShowChar(CurXPos, CurYPos, (unsigned char)(data & 0xFF));			
					CurXPos++;
					break;
			}
			break;				
  }

  return true;
}

void wnd_write_page(unsigned char address)
{ 
	page_address = address;
	CurXPos = 0;
	CurYPos = 1;	
  console_OpenWnd(&Wnd);
	i = 0;
}
