#ifndef __HY28B_DRV_H__
#define __HY28B_DRV_H__

#include "disp.h"

#ifdef __HY28B__

#define MAX_Y  240
#define MAX_X  320   

#define HY_FONT_Y	20//11//16
#define HY_FONT_X	16

#define SPI_START   (0x70)              /* Start byte for SPI transfer        */
#define SPI_RD      (0x01)              /* WR bit 1 within start              */
#define SPI_WR      (0x00)              /* WR bit 0 within start              */
#define SPI_DATA    (0x02)              /* RS bit 1 within start byte         */
#define SPI_INDEX   (0x00)              /* RS bit 0 within start byte         */

/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Grey           0xF7DE
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

#define RGB565CONVERT(red, green, blue)\
				(uint16_t)(((red >> 3) << 11)|\
				((green >> 2) << 5)|\
				(blue  >> 3))

void hy28b_Init(void);
void hy28b_Clear(unsigned short color);
unsigned short hy28b_GetPoint(unsigned short Xpos, unsigned short Ypos);
void hy28b_SetPoint(unsigned short Xpos, unsigned short Ypos, unsigned short point);
void hy28b_PrintByteScale(unsigned short Xpos, unsigned short Ypos, unsigned char byte, unsigned short charColor, unsigned short bkColor );
void hy28b_PrintChar(unsigned short Xpos, unsigned short Ypos, unsigned char ASCII, unsigned short charColor, unsigned short bkColor);
void hy28b_PrintString(unsigned short Xpos, unsigned short Ypos, unsigned char* str,unsigned short Color, unsigned short bkColor);

void hy28b_Test(void);

#endif

#endif
