#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"

#include "itmr.h"
#include "buzzer.h"

static unsigned int stime;
static unsigned char BuzzerState;
enum{
	BS_IDLE,
	BS_ON,
	BS_OFF
};

static bool IsBuzzer = false;
static unsigned int PulseLength = 500;

void buzzer_Init(void)
{
	PORT_InitTypeDef PORT_InitStructure;
	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTB, ENABLE);	
	
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_2);	
	PORT_Init(MDR_PORTB, &PORT_InitStructure);			

	stime = itmr_GetTick();
}

void buzzer_Work(void)
{
	switch(BuzzerState){
		case BS_IDLE:
			if(IsBuzzer) BuzzerState = BS_ON;
			break;
		case BS_ON:		
			PORT_WriteBit(MDR_PORTB, PORT_Pin_2, Bit_SET);
			stime = itmr_GetTick();
			BuzzerState = BS_OFF;
			break;
		case BS_OFF:
			if(itmr_IsTime(stime, PulseLength)){
				PORT_WriteBit(MDR_PORTB, PORT_Pin_2, Bit_RESET);
				BuzzerState = BS_IDLE;
				IsBuzzer = false;
			}			
			break;
	}
}

void buzzer_On(unsigned int length)
{
	IsBuzzer = true;
	PulseLength = length;
}
