#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"
#include "itmr.h"
#include "can.h"

static unsigned int TestTimer;
#define TEST_PERIOD	5000

void can_Init(void)
{
	PORT_InitTypeDef PORT_InitStructure;		
	//  C
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTC, ENABLE);	
	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	//    TxD
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;		
	PORT_InitStructure.PORT_Pin = PORT_Pin_12;
	PORT_Init(MDR_PORTC, &PORT_InitStructure);	
		
	//    - RxD
	PORT_InitStructure.PORT_OE = PORT_OE_IN;		
	PORT_InitStructure.PORT_Pin = PORT_Pin_11;	
	PORT_Init(MDR_PORTC, &PORT_InitStructure);	
}

void can_TestWork(char* write_res, char* read_res)
{
	static char flag = 0;
	
	if(itmr_IsTime(TestTimer, TEST_PERIOD)){
		if(flag){			
			PORT_WriteBit(MDR_PORTC, PORT_Pin_12, Bit_SET);	// TxD 1			
			flag = 0;
		}
		else{		
			PORT_WriteBit(MDR_PORTC, PORT_Pin_12, Bit_RESET);	// TxD 0			
			flag = 1;			
		}			
		TestTimer = itmr_GetTick();		
	}
	*write_res = flag;
	*read_res = PORT_ReadInputDataBit(MDR_PORTC, PORT_Pin_11);
}
