#include "MDR32F9Qx_uart.h"
#include "clk.h"
#include "itmr.h"
#include "led.h"
#include "button.h"
#define KEYBOARD
//#define MOUSE
#ifdef KEYBOARD
#include "keyboard.h"
#endif
#ifdef MOUSE
#include "mouse.h"
#endif
#include "rtc.h"
#include "uart.h"
#include "encoder.h"
#include "buzzer.h" 
#include "adc.h"
#include "dac.h"
#include "intro.h"
#include "console.h"
#include "disp.h"
#include "wnds.h"
#include "eth_drv.h"
#include "eth.h"
#include "terminal.h"
#include "can.h"
#include "rs485.h"
#include "error.h"
#include "wdt.h"
#include "nand_flash.h"
#include "mux.h"
#include "mcp23s18.h"

int main(void)
{		
	clk_CoreConfig();		
	itmr_Init();
	led_Init();	

	button_Init();	
	uart_Init(115200, UART_WordLength8b, UART_StopBits1, UART_Parity_No);	
	
	disp_Init();

	rtc_Init();		
#ifdef KEYBOARD
	keyboard_Init();
#endif	
#ifdef MOUSE
	mouse_Init();		
#endif	
	encoder_Init();
	buzzer_Init();
	adc_Init();
	dac_Init();
	ethernet_MACConfig();
	intro_Init();
	console_Init();
	terminal_Init();	
	rs485_Init();
	can_Init();		
	wnd_Main();			
	
	wdt_Init();	
	//nand_flash_Init();	
	//mux_Init();
	//mcp23s18_Init();
	
	while(1)
	{																						

		led_Work();			
		//nand_flash_ReadID();

		rtc_Work();					
		buzzer_Work();			
		console_Work();		
		terminal_Work();
		eth_FrameProcessing();					
		
		wdt_ReLoad();								
		//mcp23s18_Test();
	}
}
