#include <stdio.h>
#include <string.h>
#include "misc.h"
#include "itmr.h"
#include "uart.h"
#include "terminal.h"

#define CMD_MAX_LENGTH	128
static char CmdBuf[CMD_MAX_LENGTH];
static unsigned int CmdCurPos;

typedef void (*TCmdFunc)(char* cmd);

typedef struct{
	char* cmd_str;	
	TCmdFunc func;
	char session;
	char new_cmd;
	unsigned int reserv;
} TCmd;

extern void connect(char* cmd);
extern void help(char* cmd);
//extern void ipconfig(char* cmd);
extern void exitterm(char* cmd);		

#define CMD_CNT 3
static TCmd Cmd[CMD_CNT] = {
	{"connect", connect, 1, 0, 0},				//  
	{"help", help, 0, 1, 0},	
	//{"ipconfig", ipconfig, 0, 1, 0},		
	{"exit", exitterm, 0, 0, 0}
};

void connect(char* cmd){
	unsigned int cmd_ind;
	for(cmd_ind = 1; cmd_ind < CMD_CNT; cmd_ind++)
		Cmd[cmd_ind].session = 1;	
	uart_SendStr("hello: >");	
}

void help(char* cmd)
{
	uart_SendStr("help function!\r\n");		
}

/*
void ipconfig(char* cmd)
{
	uart_SendStr("ipconfig function!\r\n");
	
	if(strstr(cmd, "-mac:")){
		uart_SendStr("	mac cfg\r\n");
	}	
	if(strstr(cmd, "-ip:")){
		uart_SendStr("	ip cfg\r\n");
	}	
	if(strstr(cmd, "-mask:")){
		uart_SendStr("	mask cfg\r\n");
	}
	if(strstr(cmd, "-gateway:")){
		uart_SendStr("	gateway cfg\r\n");
	}			
}
*/
void exitterm(char* cmd){	
	unsigned int cmd_ind;
	uart_SendStr("goodbuy!\r\n");		
	for(cmd_ind = 1; cmd_ind < CMD_CNT; cmd_ind++)
		Cmd[cmd_ind].session = 0;	
}

void terminal_Init(void)
{	
	memset(CmdBuf, 0, CMD_MAX_LENGTH);
	CmdCurPos = 0;		
}

static void ProcessCmd(char* cmd)
{
	unsigned int cmd_ind;
	for(cmd_ind = 0; cmd_ind < CMD_CNT; cmd_ind++){							
			if(!strncmp(cmd, Cmd[cmd_ind].cmd_str, strlen(Cmd[cmd_ind].cmd_str))){
				if(Cmd[cmd_ind].session){ //  
					if(Cmd[cmd_ind].func) Cmd[cmd_ind].func(cmd);
					if(Cmd[cmd_ind].new_cmd)
						uart_SendStr("\r\n>");
				}
				else
					uart_SendStr("session is not exists!\r\n>");
				return;
			}
	}		
	if(CmdCurPos)
		uart_SendStr("unknown cmd!\r\n>");
}

void terminal_Work(void)
{
	char ch;
	if(uart_GetByte(&ch)){
		if(CmdCurPos < (CMD_MAX_LENGTH - 1)){
			if(ch != '\n' && ch != '\r')
				CmdBuf[CmdCurPos++] = ch;						
			if(ch == '\n'){						
				CmdBuf[CmdCurPos] = 0; // 
				ProcessCmd(CmdBuf);
				//     callback
				terminal_Init();
			}
		}
		else
			terminal_Init();
	}
}

