#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "eth_drv.h"

#define __DEBUG_WND__
#ifdef __DEBUG_WND__
	#include "uart.h"
#endif

static TEthSettings EthSettings;

static TWENumEdit neIP1 = { 0, 0, 255, 3 };
static TWENumEdit neIP2 = { 0, 0, 255, 3 };
static TWENumEdit neIP3 = { 0, 0, 255, 3 };
static TWENumEdit neIP4 = { 0, 0, 255, 3 };

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_NUM_EDIT,	0, 0, 0, "IP1: ", &neIP1)
	DEFINE_WE(WET_NUM_EDIT, 0, 1, 0, "IP2: ", &neIP2)  	
	DEFINE_WE(WET_NUM_EDIT, 0, 2, 0, "IP3: ", &neIP3)  
	DEFINE_WE(WET_NUM_EDIT, 0, 3, 0, "IP4: ", &neIP4)  	 
END_WE_TABLE()

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ETH_IP, ElemTable, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				NumEdit_SetVal(&neIP1, EthSettings.ip[0]);
				NumEdit_SetVal(&neIP2, EthSettings.ip[1]);
				NumEdit_SetVal(&neIP3, EthSettings.ip[2]);
				NumEdit_SetVal(&neIP4, EthSettings.ip[3]);				
      }
      break;
		case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 0:
					EthSettings.ip[0] = neIP1.cur_val;
					break;
				case 1:
					EthSettings.ip[1] = neIP2.cur_val;
					break;
				case 2:
					EthSettings.ip[2] = neIP3.cur_val;
					break;
				case 3:
					EthSettings.ip[3] = neIP4.cur_val;
					break;				
			}
			ethernet_SetSettings(&EthSettings);
			break;
  }

  return false;
}

void wnd_EthIP(void)
{ 
	ethernet_GetSettings(&EthSettings);	
  console_OpenWnd(&Wnd);
}
