#include <string.h>
#include <stdio.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "keyboard.h"
#include "mouse.h"
#include "button.h"

#define __DEBUG_MOUSE_WND__
#ifdef __DEBUG_MOUSE_WND__
#include "uart.h"
#define DbgSize	128
static char Dbg[DbgSize];
#endif

static TMousePos MousePos;

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_MOUSE, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{	
	TMousePos mouse_pos;
	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, " ");
      }
      break;   
		case WE_BUTTON:
			switch(data){
				case LEFT:
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_MOUSE:			
			mouse_pos = mouse_GetPos();									
			if(memcmp(&MousePos, &mouse_pos, sizeof(TMousePos))){
				disp_ShowChar(MousePos.x, disp_YSize() - MousePos.y + 1, ' ');
				MousePos = mouse_pos;						
				#ifdef __DEBUG_MOUSE_WND__
				sprintf(Dbg, "[X] %d : [Y] %d \r\n", mouse_pos.x, mouse_pos.y);
				uart_SendStr(Dbg);
				#endif
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'X');			
			}
			if(data & (1ul << 0))
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'L');				
			else
			if(data & (1ul << 1))
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'R');
			else				
			if(data & (1ul << 2))
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'M');
			else
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'X');			
			break;
  }

  return true;
}

void wnd_Mouse(void)
{ 	
  console_OpenWnd(&Wnd);
}
