#include <string.h>
#include <stdio.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "keyboard.h"
#include "button.h"
#include "can.h"
#include "nand_flash.h"
#define NF_data_size NF_PageSize + 64
#define NF_PageSize 8

unsigned int NF_data[NF_data_size];
unsigned int NF_mem_data[NF_data_size];
unsigned int i = 0 ;

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_BUTTON,   0, 4, 0, "Write Data", 0)
END_WE_TABLE()

static unsigned int ShowTimer;
static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_NAND, ElemTable, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{ char buffer[32];
	unsigned int read_id, read_status;
	read_id = nand_flash_ReadID();
	
	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, "NAND FLASH");
			sprintf(buffer, "NF DATA: %d", NF_mem_data[1]);
			disp_ShowStr(0, 5, buffer);
			//	disp_ShowStr(0, 1, write_id);
			//	disp_ShowStr(0, 2, "Tx: ");
			//	disp_ShowStr(0, 3, ". ");
			//	disp_ShowStr(0, 4, "Rx: ");			
      }
      break;   
		case WE_BUTTON:
			switch(data){
				case LEFT:
					console_CloseWnd(0);
					break;
				case SELECT:					
					nand_flash_BlockErase(0);
					read_status = nand_flash_ReadStatus();
					sprintf(buffer, "STATUS: %d", read_status);
					disp_ShowStr(0, 2, buffer);
				itmr_Delay(1000);
				
				  nand_flash_ReadPage(0,0, NF_mem_data);
				  sprintf(buffer, "NF DATA: %d", NF_mem_data[1]);
					disp_ShowStr(0, 5, buffer);
				itmr_Delay(1000);
				
				  nand_flash_WritePage(0,0,NF_data);
					read_status = nand_flash_ReadStatus();
					sprintf(buffer, "STATUS: %d", read_status);
					disp_ShowStr(0, 2, buffer);
					itmr_Delay(1000);					
				
					read_status = nand_flash_ReadStatus();
					sprintf(buffer, "STATUS: %d", read_status);
					disp_ShowStr(0, 2, buffer);
					itmr_Delay(1000);
          
				//	memset(NF_data,0xFF,NF_data_size);
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					console_CloseWnd(0);
					break;				
			}
			break;
		
		case WE_CYCLE:
			//can_TestWork(&write_res, &read_res);
			
	  	sprintf(buffer, "ID: %d", read_id);
			disp_ShowStr(0, 1, buffer);
		  /*read_status = nand_flash_ReadStatus();
			sprintf(buffer, "STATUS: %d", read_status);
			disp_ShowStr(0, 2, buffer);*/
		  
		  sprintf(buffer, "Generated DATA: %d", NF_data[1]);
			disp_ShowStr(0, 3, buffer);		  
		  if(itmr_IsTime(ShowTimer, 100ul)){			
			//sprintf(buffer, "STATUS: %d", read_status);
			//disp_ShowStr(0, 2, buffer);
			nand_flash_ReadPage(0,0,NF_mem_data);				
				
			sprintf(buffer, "NF DATA: %d", NF_mem_data[0]);
			disp_ShowStr(0, 5, buffer);	
					
				
			//	disp_ShowStr(4, 2, write_res ? " 1" : " 0");	
			//	disp_ShowStr(4, 4, read_res ? " 1" : " 0");	
			}
			break;
		case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 4:		
					
					break;
			}
			break;
  }
	
  return true;
}

void wnd_NAND(void)
{  console_OpenWnd(&Wnd);	
	 nand_flash_Init();
	for ( i=0; i< NF_data_size; i++)
			{NF_mem_data[i]=0;}
	 nand_flash_ReadPage(0,0, NF_mem_data);
	 //memset(NF_data,0xFF,NF_data_size);
		
		for ( i=0; i< NF_data_size; i++)
			{NF_data[i]=i*2;}
			
		//NF_data[0] = 11;
}
