#include "MDR1986VE1T.h"
#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_eeprom.h"
#include "error.h"

void clk_CoreConfig(void)
{  
	// Enable HSE (High Speed External) clock
  RST_CLK_HSEconfig(RST_CLK_HSE_ON);
  if (RST_CLK_HSEstatus() == ERROR) error_SetError(HSE_ERROR);//while (1);  	
		
  // Configures the CPU_PLL clock source 
  RST_CLK_CPU_PLLconfig(RST_CLK_CPU_PLLsrcHSEdiv1, RST_CLK_CPU_PLLmul6);

  // Enables the CPU_PLL 
  RST_CLK_CPU_PLLcmd(ENABLE);
  if (RST_CLK_CPU_PLLstatus() == ERROR) error_SetError(PLL_ERROR);//while (1);  

  // Enables the RST_CLK_PCLK_EEPROM 
  RST_CLK_PCLKcmd(RST_CLK_PCLK_EEPROM, ENABLE);
  // Sets the code latency value 
  EEPROM_SetLatency(EEPROM_Latency_4);

  // Select the CPU_PLL output as input for CPU_C3_SEL
  RST_CLK_CPU_PLLuse(ENABLE);
  // Set CPUClk Prescaler 
  RST_CLK_CPUclkPrescaler(RST_CLK_CPUclkDIV1);

  // Select the CPU clock source 
  RST_CLK_CPUclkSelection(RST_CLK_CPUclkCPU_C3);

  // Enables the RTCHSE clock on all ports 
  //RST_CLK_PCLKcmd(ALL_PORTS_CLK, ENABLE);

  MDR_RST_CLK->PER_CLOCK = 0xFFFFFFFF;			
}
