#include "MDR32F9Qx_uart.h"
#include "clk.h"
#include "itmr.h"
#include "led.h"
#include "button.h"
#include "console.h"
#include "keyboard.h"
#include "rtc.h"
#include "uart.h"
#include "encoder.h"
#include "buzzer.h" 
#include "adc.h"
#include "dac.h"
#include "intro.h"

#include "disp.h"
#include "wnds.h"
#include "eth_drv.h"
#include "eth.h"
#include "terminal.h"
#include "can.h"
#include "rs485.h"
#include "error.h"
#include "wdt.h"
#include "nand_flash.h"

#define WITHOUT_FUNC
//#define FUNC						// For LDM_HELPER_FUNC

//------LDM_HELPER_FUNC------//
#ifdef FUNC
#include "wnds_func.h"
#endif
#ifdef WITHOUT_FUNC
#include "wnds.h"
#endif

#include "func_main.h"
#include "ds1339_RTC.h"
#include "buzzer_melody.h"
#include "main.h"

 unsigned int time_buf[10];
 unsigned short temp_buf[10];
 unsigned short pres_buf[10];
 unsigned short adc_result2;
 
//------LDM_HELPER_FUNC------//
extern char wnd_choose = 1;

int main(void)
{		char buffer[32];
			
	clk_CoreConfig();		
	itmr_Init();
	led_Init();	

	button_Init();	
	uart_Init(115200, UART_WordLength8b, UART_StopBits1, UART_Parity_No);	
	
	disp_Init();

	rtc_Init();		

	keyboard_Init();

	encoder_Init();
	buzzer_Init();
	adc_Init();
	dac_Init();
	ethernet_MACConfig();
	intro_Init();
	console_Init();
	terminal_Init();	
	rs485_Init();
	can_Init();	

	#ifdef FUNC
	func_Init();
	wnd_MainFUNC();	
	#endif
	#ifdef WITHOUT_FUNC
	wnd_Main();
	#endif

	wdt_Init();	
	
	clear_log_loop();
		rtc_Init();	
	while(1)
	{																						

		led_Work();		
	
		rtc_Work();					
		buzzer_Work();			
		console_Work();		
		terminal_Work();
		eth_FrameProcessing();					
		
		wdt_ReLoad();								
		
		#ifdef FUNC
		alarm_Work();
		log_loop(time_buf,temp_buf,pres_buf);
		#endif
		
	}
}

