
#define _BVD( x ) ((uint32_t)( 1 ) << ( x ))

unsigned char random_byte_lfsr32(void)
{    
    static unsigned int lfsr = 0xDEADBEEF;
       
    unsigned char state;

    for (state = 0; state <= 8; state++)
    {
        unsigned char new_bit = 0;
/*
#ifndef OPTIMIZED_LFSR32
       
        if ( lfsr & _BVD(1) )
            new_bit ^= 1;
        if ( lfsr & _BVD(5) )
            new_bit ^= 1;
        if ( lfsr & _BVD(6) )
            new_bit ^= 1;
        if ( lfsr & _BVD(31) )
            new_bit ^= 1;
       
        lfsr >>= 1 ;
        lfsr |= (unsigned int)( new_bit ) << 31;

#else
*/
        asm volatile(

            "sbrc %a0, 1"                                  "\n\t"
            "eor %1, %4"                                   "\n\t"
            "sbrc %a0, 5"                                  "\n\t"
            "eor %1, %4"                                   "\n\t"
            "sbrc %a0, 6"                                  "\n\t"
            "eor %1, %4"                                   "\n\t"
            "sbrc %d0, 7"                                  "\n\t"
            "eor %1, %4"                                   "\n\t"

            "lsr %d0"                                      "\n\t"
            "ror %c0"                                      "\n\t"
            "ror %b0"                                      "\n\t"
            "ror %a0"                                      "\n\t"

            "sbrc %1, 0"                                   "\n\t"
            "ori %d0, %5"                                  "\n\t"

            : "=r" ( lfsr ), "=d" ( new_bit )

            : "0" ( lfsr ), "1" ( new_bit ), "d" ( 0x01 ), 
                "m" ( 0x80 )
            );
#endif
    }
   
    return (unsigned char)( lfsr & 0xFF );
}

unsigned char random_byte_in(unsigned char min, unsigned char max)
{
	unsigned int a_random_byte = random_byte_lfsr32();
   
    a_random_byte *= (max - min + 1);
    
    return (unsigned char)( (a_random_byte >> 8) + min );
}

unsigned char random_ubyte_in(unsigned char min, unsigned char max)
{
		unsigned int a_random_byte = random_byte_lfsr32();
    
    a_random_byte *= (max - min + 1);
   
    return (unsigned char)( (a_random_byte >> 8) + min );
}

