#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "keyboard.h"
#include "button.h"
#include "can.h"
#include "nand_flash.h"
#include "uart.h"
#include "adc.h"
#include <rtc.h>
#define NF_data_size NF_PageSize + 64		//K9
#define NF_PageSize 2048								//K9

//#define NF_PageSize 512										//HY27
//#define NF_data_size NF_PageSize + 16			//HY27

static char ADCRes[32];

//unsigned char NF_data[NF_data_size];
unsigned char NF_mem_data[NF_data_size];
//char read_buf_id[4];
unsigned int i = 0 ;
unsigned char generated_num = 0;
unsigned int block = 1, page = 1;
unsigned char nand_type = 0;

BEGIN_WE_TABLE(ElemTable)
  DEFINE_WE(WET_BUTTON,   0, 0, 0, "NAND ID:", 0)
	DEFINE_WE(WET_BUTTON,   0, 1, 0, "  ", 0)	
	DEFINE_WE(WET_BUTTON,   0, 2, 0, " ", 0) 
	DEFINE_WE(WET_BUTTON,   0, 3, 0, "  ", 0)
	DEFINE_WE(WET_BUTTON,   0, 4, 0, ". . ", 0)
	
END_WE_TABLE()


static bool EventProc(unsigned int code, unsigned int data);

int write_operation(void);
int read_operation(void);

static TWnd Wnd = { WID_NAND, ElemTable, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{ char buffer[32];	

	unsigned int read_id;
	
	unsigned int sample;

	TTime CurTime = rtc_GetTime();
		  
	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {				
				}				     
      break; 
		
		case WE_CYCLE:
					//ADC
						if(adc_Work(&sample))
						{				
						  sprintf(ADCRes, ": %3.3f%%", (float)sample * 100/ adc_GetMaxVal());
							disp_ShowStr(0, 5, ADCRes);														
						}							
			break;
		
		case WE_ELEM_ACT:
			switch(Wnd.cur_elem){
				case 0:
					//read id
						read_id = nand_flash_ReadID();	
						sprintf(buffer, " %x", read_id);
						disp_ShowStr(10, 0, buffer);	
				
					break;
				case 1:		
						nand_flash_ReadPage(block, page, NF_mem_data, NF_data_size,nand_type);	//page <-> block
						read_operation();				  	
					break;
				case 2:		
					nand_flash_BlockErase(block, page,nand_type);		
						if (nand_flash_ReadStatus() == 1)
							{	block = (block + 1)%4096;
							}
					break;
				case 3:		
								write_operation();
					break;
				case 4:		
					//Generate and display number	  
						srand(CurTime.msec);
						generated_num = (char) rand();
						sprintf(buffer, "%d", generated_num);
						disp_ShowStr(17, 4, buffer);
					break;
			}
			break;
  }
	
  return false;
}

unsigned char nand_flash_type(void)
{	unsigned int id;
	
	id = nand_flash_ReadID();
	id = (id >> 24);
	 if (id == 0xF1)
	 {	return (0);
	 }
	 else
	 {	return (1);
	 }
	
}
int read_operation(void)
{	 char buffer[32];
		//NAND FLASH DATA
					//Random
				if (NF_mem_data[0] == 255){
					sprintf(buffer, "NF .: %d", 0);
					disp_ShowStr(0, 6, buffer);
				}
				else
				{
					sprintf(buffer, "NF .: %d", NF_mem_data[0]);
					disp_ShowStr(0, 6, buffer);
				}
					itmr_Delay(1000);
					// NAND FLASH ADC
					for (i=0; i<32; i++){
						buffer[i] = NF_mem_data[i+1];
					}
					if (NF_mem_data[1] < 0xFF ){
					disp_ShowStr(0, 6, "NF ");
					disp_ShowStr(4, 6, buffer);
					}
					else {
						sprintf(buffer, "NF : %d", 0);
						disp_ShowStr(0, 6, buffer);
					}
					itmr_Delay(1000);
					// NAND FLASH TIME
					for (i=0; i<32; i++){
						buffer[i] = NF_mem_data[i+34];
					}
					
					if (NF_mem_data[34] < 0xFF ){
						sprintf(buffer, "NF : %d.0%d.%d ", NF_mem_data[34],NF_mem_data[35],NF_mem_data[36]);						
						disp_ShowStr(0, 6, buffer);			
						sprintf(buffer, "NF : %d : %d", NF_mem_data[37],NF_mem_data[38]);						
						disp_ShowStr(0, 7, buffer);						
						}
					else {
						sprintf(buffer, "NF : %d", 0);
						disp_ShowStr(0, 6, buffer);
						disp_ShowStr(0, 7, "                    ");	
					}
					itmr_Delay(1000);
return 1;
}
int write_operation(void)
{ TTime CurTime = rtc_GetTime();
	nand_flash_BlockErase(block, page,nand_type);
	if (nand_flash_ReadStatus() == 1)
		{
			block = (block + 1)%4096;
		  nand_flash_BlockErase(block, page,nand_type);
		}
	itmr_Delay(10);
  NF_mem_data[0] = generated_num;							
	for (i = 1; i<33; i++)
	{
		NF_mem_data[i] = ADCRes[i-1];
	}						
						
	NF_mem_data[34] = CurTime.date;
	NF_mem_data[35] = CurTime.month;
	NF_mem_data[36] = CurTime.year-2000;
	NF_mem_data[37] = CurTime.hour;
	NF_mem_data[38] = CurTime.min;
								
	nand_flash_WritePage(block, page, NF_mem_data, NF_data_size,nand_type);
	if (nand_flash_ReadStatus() == 1)
	{
		block++;
	}
	memset(NF_mem_data,0xFF,NF_data_size);
return 1;
}
void wnd_NAND(void)
{  
	console_OpenWnd(&Wnd);	
	nand_flash_Init();
	nand_flash_ReadID();
	
	memset(NF_mem_data,0xFF,NF_data_size);
	nand_type = nand_flash_type();
	
	//read page
	nand_flash_ReadPage(page, block, NF_mem_data, NF_data_size,nand_type);		
}
