#include <stdio.h>
#include <string.h>
#include "itmr.h"
#include "disp.h"
#include "console.h"
#include "wnds.h"
#include "keyboard.h"
#include "button.h"
#include "adc.h"
#include "dac.h"
#include "uart.h"

static char ADCRes[32];

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ADC, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  unsigned int sample;
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, " .:");				
				disp_ShowStr(0, 2, " .:");				
      }
      break;
		case WE_BUTTON:
			switch(data){
				case LEFT:
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_CYCLE:								
			if(adc_Work(&sample)){				
				
				sprintf(ADCRes, "%3.3f% ", (float)706*sample/1000 );
				disp_ShowStr(0, 1, ADCRes);
				sprintf(ADCRes, "%3.3f%%", (float)dac_Work() * 100/ dac_GetMaxVal());
				disp_ShowStr(0, 3, ADCRes);							
			}
			
			break;
  }

  return true;
}

void wnd_ADC(void)
{ 
  adc_Init();
	console_OpenWnd(&Wnd);
}
